export declare type RetryError<T = unknown> = Error & {
    yielded?: T;
};
export declare type GeneratorFactory<Args extends any[] = any[]> = (...args: Args) => any;
export declare type ConditionFunction = (v: unknown) => boolean;
export interface RetryGeneratorOptions {
    backoff?: (attempt: number) => number;
    condition?: RegExp | ConditionFunction;
    retries?: number;
}
