/**
 * Exponential growth function.
 * Useful to sparse API calls.
 * [400, 800, 1600, 3200, 6400, ...]
 *
 * @param {number} attempt
 *
 * @returns {number}
 */
export declare function exponentialGrowth(attempt: number): number;
/**
 * Linear growth function.
 * Useful to sparse API calls.
 * [400, 800, 1200, 1600, 2000, ...]
 *
 * @param {number} attempt
 *
 * @returns {number}
 */
export declare function linearGrowth(attempt: number): number;
